#! /usr/bin/env python
import random as r
import time as t

#Format: Chemistry, Physics, Mathematics, Name, ID, Chain
all_cards = [((0,0), (0,0), (1,1) , "Elementary Algebra"    , 1, []),
             ((2,1), (1,1), (1,0) , "Chemical Elements"     , 2, [(1,"Elem. Algebra")]),
             ((1,0), (0,0), (2,2) , "Abstract Algebra"      , 3, [(1,"Elem. Algebra")]),
             ((1,0), (0,0), (5,5) , "Mathematical Analysis" , 4, [(3,"Abs. Algebra")]),
             ((1,1), (1,1), (1,0) , "Energy"                , 5, [(3,"Abs. Algebra"),(4,"M. Analysis")]),
             ((0,0), (1,1), (1,0) , "Atoms"                 , 6, []),
             ((2,2), (2,2), (1,0) , "Molecules"             , 7, [(1,"Elem. Algebra"), (6,"Atoms"), (5,"Energy")]),
             ((0,0), (1,1), (1,0) , "Kinetics"              , 8, [(4,"M. Analysis")]),
             ((1,1), (1,1), (1,0) , "Gases"                 , 9, [(4,"M. Analysis"), (7,"Molecules")]),
             ((1,1), (1,1), (1,0) , "Toughness"             ,10, [(7,"Molecules"), (8,"Kinetics")]),
             ((0,0), (5,5), (1,0) , "Nuclear Physics"       ,11, [(6,"Atoms"), (5,"Energy")]),
             ((5,5), (0,0), (1,0) , "Inorganic Chemistry"   ,12, [(7,"Molecules"), (5,"Energy"), (2, "Chem. Elem.")]),
             ((5,5), (0,0), (1,0) , "Organic Chemistry"     ,13, [(7,"Molecules"), (5,"Energy"), (2, "Chem. Elem.")]),
             ((5,5), (0,0), (1,0) , "Medicine"              ,14, [(13,"Org. Chem."), (12,"Inorg. Chem."), (7,"Molecules")]),
             ((0,0), (5,5), (1,0) , "Aerodynamics"          ,15, [(8, "Kinetics"), (4, "M. Analysis"), (9, "Gases")]),
             ((4,3), (4,3), (1,0) , "Fuels"                 ,16, [(13,"Org. Chem."), (5,"Energy"), (12,"Inorg. Chem.")]),
             ((1,0), (5,5), (1,0) , "Mechanics"             ,17, [(8, "Kinetics"), (5,"Energy"), (4,"M. Analysis")]),
             ((4,3), (4,3), (1,0) , "Building Materials"    ,18, [(12,"Inorg. Chem."), (10,"Toughness"), (7,"Molecules")]),
             ((1,0), (0,0), (7,6) , "Automation"            ,19, [(1, "Elem. Algebra"), (3,"Abs. Algebra"), (4, "M. Analysis")]),
             ((4,4), (4,4), (1,0) , "Ventilation"           ,20, [(8,"Kinetics"), (9,"Gases"), (17, "Mechanics")])]
DELAY = 0.25
myskohand=[]
yourhand =[]

myskotable = []
yourtable  = []

def yourscore(table):
    score = (0,0,0)
    i = 1
    while i<=len(table):
        current_card_score = 0
        t = table[:i]
        current_card_score = (t[-1][0][1],t[-1][1][1],t[-1][2][1])
        multiplier = 1
        for card in t:
            for buff in t[-1][5]:
                if buff[0] == card[4]:
                    multiplier*=2
        score = (score[0] + multiplier * current_card_score[0],
                 score[1] + multiplier * current_card_score[1],
                 score[2] + multiplier * current_card_score[2])
        i+=1
    return score

def myskoscore(table):
    score = (0,0,0)
    i = 1
    while i<len(table):
        current_card_score = 0
        t = table[:i]
        current_card_score = (t[-1][0][0],t[-1][1][0],t[-1][2][0])
        multiplier = 1
        for card in t:
            for buff in t[-1][5]:
                if buff[0] == card[4]:
                    multiplier*=2
        score = (score[0] + multiplier * current_card_score[0],
                 score[1] + multiplier * current_card_score[1],
                 score[2] + multiplier * current_card_score[2])
        i+=1
    return score


def show_card(x):
    t.sleep(DELAY)
    print ""
    print " ",x[3],"<",x[4],">"
    print "  M:",x[0][0],x[1][0],x[2][0],"Y:",x[0][1],x[1][1],x[2][1]
    print "  Imporved by:",
    for y in x[5]:
        print '"'+y[1]+'"',
    print "\n",

def deal_cards(pile, n):
    r = []
    for x in range(n):
        r += [pile.pop()]
    return r

def myskoplay(myskohand):
    return myskohand.pop(r.randint(0,len(myskohand)-1))

def youplay(yourhand,yourtable,myskotable):
    print "2. Y o u r  h a n d:"
    for x in yourhand:
        show_card(x)
    x=-1
    while(x<0 or x>4):
        x = int(raw_input("\n\n\tPick a card (1-5):")) - 1

    return yourhand.pop(x)

def main():
    for x in range(100):
        print ""
    print "\t\t\tM Y S K O  M A N N E N"
    print "\t\t\t     The card game    "
    print ""
    print ""
    print ""
    print ""
    print ""
    print ""
    print ""
    print "Some evil geniuses are too busy being evil to be geniuses"
    raw_input("Press enter to start playing")
    
    cards = r.sample(all_cards,len(all_cards))
    myskohand = []
    yourhand  = []

    myskotable = []
    yourtable  = []

    myskohand += deal_cards(cards,5)
    yourhand  += deal_cards(cards,5)
    
    
    while(cards != []):
        print ""
        print "I t  i s  M y s k o m a n n e ns  t u r n"
        print ""
        myskotable += [myskoplay(myskohand)]
        print "Myskomannen plays:\n"
        t.sleep(0.1*r.randint(1,10))
        show_card(myskotable[-1])
        t.sleep(DELAY)
        print "\nMyskomannen has played the following cards so far (from oldest to newest):"
        for x in myskotable:
            show_card(x)

        raw_input("Press enter to continue")
        myskohand += deal_cards(cards,1)
        
        print ""
        print "I t  i s  y o u r  t u r n"
        print ""
        print "1. You have played the following cards:"
        for x in yourtable:
            show_card(x)

        raw_input("Press enter to continue")
        yourtable += [youplay(yourhand,yourtable,myskotable)]
        yourhand  += deal_cards(cards,1)

    
    your_score = yourscore(yourtable)
    mysko_score = myskoscore(myskotable)
    standing = 0
    print "M  Y"
    for i in range(3):
        print mysko_score[i], your_score[i]
        if(your_score[i]>mysko_score[i]): standing+=1
        else: standing -=1

    print "Standing:", standing
    if(standing > 0):
        print "Myskomannen was defeated"
    else:
        print "Myskomannen wins!"
main()
